function simulapendulo(z);

if nargin<1
    z=[0 30 0 0 0];
end

%
% Simula o pendulo invertido!
%
% Considerando o estado inicial z;
%

tmax=2*60;
xmax=100;
% Enquanto |theta|<90 E |theta| e |delta theta|>1.e-2 E |posicao|<xmax E tempo<tmax
while (abs(z(2))<=90)&(max([abs(z(2)),abs(z(3)),abs(z(5))])>1.e-2)&(abs(z(4))<xmax)&(z(1)<tmax)
    
    %
    % Inclua aqui o controlador fuzzy que fornece a aceleração a;
    %
    a=controladorfuzzy(z);
    
    % Determina o próximo estado do pendulo!
    [z,L]=pendmotion(z,a);
    
    % Desenha o pendulo;
    figure(1);
    subplot(2,1,1);
    plot([z(4) (z(4)+L*sin(pi*z(2)/180))],[0 L*cos(pi*z(2)/180)],'-b',z(4),0,'sb','LineWidth',4);
    axis([-xmax xmax 0 2*L]); grid;
    title(sprintf('Tempo: %2.2f',z(1)));
    subplot(2,1,2);
    plot([z(4) (z(4)+L*sin(pi*z(2)/180))],[0 max(0,L*cos(pi*z(2)/180))],'LineWidth',4);
    axis([z(4)-L,z(4)+L,0,L]); grid;
    title(sprintf('Tempo: %2.2f',z(1)));
    disp(z');
    pause(1.e-4);
end

if (max([abs(z(2)),abs(z(3)),abs(z(5))])<1.e-2)
    disp('Parabéns, você equilibrou o pendulo invertido!');
end

if (abs(z(2))>90)
    disp('O pendulo caiu!');
end

if (abs(z(4))>xmax)
    disp('Você saiu da área permitida!');
end

if (z(1)>tmax)
    disp('Parabéns! Você conseguiu equilibrar o pendulo invertido!');
end

